VTK: vtkHyperTreeGridGeometricLocator Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
vtkHyperTreeGridGeometricLocator Class Reference

class that implements accelerated searches through HyperTree Grids (HTGs) using geometric information More...

`#include <vtkHyperTreeGridGeometricLocator.h>`

Inheritance diagram for vtkHyperTreeGridGeometricLocator:
[legend]
Collaboration diagram for vtkHyperTreeGridGeometricLocator:
[legend]

## Public Types
typedef vtkHyperTreeGridLocator | Superclass
Public Types inherited from vtkHyperTreeGridLocator
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkHyperTreeGridGeometricLocator * | NewInstance () const
void | SetHTG (vtkHyperTreeGrid *candHTG) override
| Set the vtkHyperTreeGrid to use for locating. More...
vtkIdType | Search (const double point[3]) override
| Basic search for cell holding a given point. More...
vtkIdType | Search (const double point[3], vtkHyperTreeGridNonOrientedGeometryCursor *cursor)
| Basic search for cell holding a given point that also return a cursor. More...
vtkIdType | FindCell (const double point[3], double tol, vtkGenericCell *cell, int &subId, double pcoords[3], double *weights) override
| Find the cell where a given point lies. More...
int | IntersectWithLine (const double p0[3], const double p1[3], double tol, double &t, double x[3], double pcoords[3], int &subId, vtkIdType &cellId, vtkGenericCell *cell) override
| Find first intersection of the line defined by (p0, p1) with the HTG. More...
int | IntersectWithLine (const double p0[3], const double p1[3], double tol, vtkPoints *points, vtkIdList *cellIds, vtkGenericCell *cell) override
| Find all intersections of the line defined by (p0, p1) with the HTG. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
Public Member Functions inherited from vtkHyperTreeGridLocator
vtkHyperTreeGridLocator * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
virtual vtkHyperTreeGrid * | GetHTG ()
| Getter/Setter methods for setting the vtkHyperTreeGrid. More...
virtual void | Initialize ()
| Initialize or reinitialize the locator (setting or re-setting clean objects in memory) (Does nothing) More...
virtual void | Update ()
| Update the locator's internal variables with respect to changes that could have happened outside. More...
virtual void | SetTolerance (double)
| Get/Set tolerance used when searching for cells in the HTG. More...
virtual double | GetTolerance ()
| Get/Set tolerance used when searching for cells in the HTG. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkHyperTreeGridGeometricLocator * | SafeDownCast (vtkObjectBase *o)
static vtkHyperTreeGridGeometricLocator * | New ()
Static Public Member Functions inherited from vtkHyperTreeGridLocator
static vtkTypeBool | IsTypeOf (const char *type)
static vtkHyperTreeGridLocator * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkHyperTreeGridGeometricLocator ()=default
| ~vtkHyperTreeGridGeometricLocator () override=default
vtkIdType | RecursiveSearch (vtkHyperTreeGridNonOrientedGeometryCursor *cursor, const double pt[3])
| The recursive part of the point search. More...
vtkIdType | RecurseSingleIntersectWithLine (const double p0[3], const double p1[3], double tol, vtkHyperTreeGridNonOrientedGeometryCursor *cursor, vtkGenericCell *cell, double &t, int &subId, double x[3], double pcoords[3]) const
| Recursive part of single line intersection search. More...
void | RecurseAllIntersectsWithLine (const double p0[3], const double p1[3], double tol, vtkHyperTreeGridNonOrientedGeometryCursor *cursor, std::vector< double > *ts, vtkPoints *points, vtkIdList *cellIds, vtkGenericCell *cell) const
| Recursive part of all line intersections search. More...
Protected Member Functions inherited from vtkHyperTreeGridLocator
| vtkHyperTreeGridLocator ()=default
| ~vtkHyperTreeGridLocator () override=default
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()
Protected Attributes inherited from vtkHyperTreeGridLocator
vtkWeakPointer< vtkHyperTreeGrid > | HTG
| Internal reference to the HyperTreeGrid one wants to search over. More...
double | Tolerance = 0.0
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

class that implements accelerated searches through HyperTree Grids (HTGs) using geometric information

The goal of this class is to implement a geometric locator search through the HTG structure. Its main feature should be to expose a generic interface to finding the HTG cells that contain a given geometric object. The search through the HTG is implemented using a vtkHyperTreeGridNonOrientedGeometricCursor. The arborescent structure of the HTG should be sufficient to accelerate the search and achieve good performance in general.

All methods in this class should be thread safe since it is meant to be used in a multi-threaded environment out of the box (except SetHTG which should be called outside any multi-threaded setting).

See also
  vtkHyperTreeGridLocator, vtkHyperTreeGrid, vtkHyperTree, vtkHyperTreeGridOrientedCursor, vtkHyperTreeGridNonOrientedCursor

Tests:
  vtkHyperTreeGridGeometricLocator (Tests)

Definition at line 38 of file vtkHyperTreeGridGeometricLocator.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkHyperTreeGridLocator vtkHyperTreeGridGeometricLocator::Superclass

Definition at line 41 of file vtkHyperTreeGridGeometricLocator.h.

## Constructor & Destructor Documentation

## ◆ vtkHyperTreeGridGeometricLocator()

vtkHyperTreeGridGeometricLocator::vtkHyperTreeGridGeometricLocator | ( |  | ) |
| protecteddefault

## ◆ ~vtkHyperTreeGridGeometricLocator()

vtkHyperTreeGridGeometricLocator::~vtkHyperTreeGridGeometricLocator | ( |  | ) |
| overrideprotecteddefault

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkHyperTreeGridGeometricLocator::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkHyperTreeGridGeometricLocator::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkHyperTreeGridLocator.

## ◆ SafeDownCast()

static vtkHyperTreeGridGeometricLocator* vtkHyperTreeGridGeometricLocator::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkHyperTreeGridGeometricLocator::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkHyperTreeGridLocator.

## ◆ NewInstance()

vtkHyperTreeGridGeometricLocator* vtkHyperTreeGridGeometricLocator::NewInstance | ( |  | ) | const

## ◆ New()

static vtkHyperTreeGridGeometricLocator* vtkHyperTreeGridGeometricLocator::New | ( |  | ) |
| static

## ◆ SetHTG()

void vtkHyperTreeGridGeometricLocator::SetHTG | ( | vtkHyperTreeGrid * | candHTG | ) |
| overridevirtual

Set the vtkHyperTreeGrid to use for locating.

Reimplemented from vtkHyperTreeGridLocator.

## ◆ Search() [1/2]

vtkIdType vtkHyperTreeGridGeometricLocator::Search | ( | const double | point[3] | ) |
| overridevirtual

Basic search for cell holding a given point.

Parameters

  point | coordinated of sought point

Returns
  the global index of the cell holding the point (-1 if cell not found or masked)

Implements vtkHyperTreeGridLocator.

## ◆ Search() [2/2]

vtkIdType vtkHyperTreeGridGeometricLocator::Search | ( | const double | point[3],
|  | vtkHyperTreeGridNonOrientedGeometryCursor * | cursor
| ) |  |

Basic search for cell holding a given point that also return a cursor.

Parameters

  | point | coordinated of sought point
  [out] | cursor | the cursor at the cell holding the point

Returns
  the global index of the cell holding the point (-1 if cell not found or masked)

## ◆ FindCell()

vtkIdType vtkHyperTreeGridGeometricLocator::FindCell | ( | const double | point[3],
|  | double | tol,
|  | vtkGenericCell * | cell,
|  | int & | subId,
|  | double | pcoords[3],
|  | double * | weights
| ) |  |
| overridevirtual

Find the cell where a given point lies.

Parameters

  [in] | point | an array holding the coordinates of the point to search for
  [in] | tol | tolerance level
  [out] | cell | pointer to a cell configured with information from return value cell index
  [out] | subId | index of the sub cell if composite cell
  [out] | pcoords | parametric coordinates of the point in the cell
  [out] | weights | interpolation weights of the sought point in the cell

Returns
  the global index of the cell holding the point (-1 if no cell is found or is masked)

Implements vtkHyperTreeGridLocator.

## ◆ IntersectWithLine() [1/2]

int vtkHyperTreeGridGeometricLocator::IntersectWithLine | ( | const double | p0[3],
|  | const double | p1[3],
|  | double | tol,
|  | double & | t,
|  | double | x[3],
|  | double | pcoords[3],
|  | int & | subId,
|  | vtkIdType & | cellId,
|  | vtkGenericCell * | cell
| ) |  |
| overridevirtual

Find first intersection of the line defined by (p0, p1) with the HTG.

Parameters

  [in] | p0 | first point of the line
  [in] | p1 | second point of the line
  [in] | tol | tolerance level
  [out] | t | pseudo-time along line path at intersection
  [out] | x | intersection point
  [out] | pcoords | parametric coordinatesof intersection
  [out] | subId | index of the sub cell if composite cell
  [out] | cellId | the global index of the intersected cell
  [out] | cell | pointer to a vtkCell object corresponding to cellId

Returns
  an integer with 0 if no intersection could be found

Implements vtkHyperTreeGridLocator.

## ◆ IntersectWithLine() [2/2]

int vtkHyperTreeGridGeometricLocator::IntersectWithLine | ( | const double | p0[3],
|  | const double | p1[3],
|  | double | tol,
|  | vtkPoints * | points,
|  | vtkIdList * | cellIds,
|  | vtkGenericCell * | cell
| ) |  |
| overridevirtual

Find all intersections of the line defined by (p0, p1) with the HTG.

Parameters

  [in] | p0 | first point of the line
  [in] | p1 | second point of the line
  [in] | tol | tolerance level
  [out] | points | array of points on the line intersecting the HTG
  [out] | cellIds | array of cellIds holding the different points of the points array
  [out] | cell | pointer to a vtkCell object corresponding to the last cellId found

Returns
  an integer with 0 if no intersection could be found

Implements vtkHyperTreeGridLocator.

## ◆ RecursiveSearch()

vtkIdType vtkHyperTreeGridGeometricLocator::RecursiveSearch | ( | vtkHyperTreeGridNonOrientedGeometryCursor * | cursor,
|  | const double | pt[3]
| ) |  |
| protected

The recursive part of the point search.

## ◆ RecurseSingleIntersectWithLine()

vtkIdType vtkHyperTreeGridGeometricLocator::RecurseSingleIntersectWithLine | ( | const double | p0[3],
|  | const double | p1[3],
|  | double | tol,
|  | vtkHyperTreeGridNonOrientedGeometryCursor * | cursor,
|  | vtkGenericCell * | cell,
|  | double & | t,
|  | int & | subId,
|  | double | x[3],
|  | double | pcoords[3]
| ) |  | const
| protected

Recursive part of single line intersection search.

## ◆ RecurseAllIntersectsWithLine()

void vtkHyperTreeGridGeometricLocator::RecurseAllIntersectsWithLine | ( | const double | p0[3],
|  | const double | p1[3],
|  | double | tol,
|  | vtkHyperTreeGridNonOrientedGeometryCursor * | cursor,
|  | std::vector< double > * | ts,
|  | vtkPoints * | points,
|  | vtkIdList * | cellIds,
|  | vtkGenericCell * | cell
| ) |  | const
| protected

Recursive part of all line intersections search.

## ◆ PrintSelf()

void vtkHyperTreeGridLocator::PrintSelf
| override

The documentation for this class was generated from the following file:

- Common/DataModel/vtkHyperTreeGridGeometricLocator.h